// Backs up stuff to the network share
#include <readconfig.c>
#include <rnd/strconcat.c>
#include <rnd/explode.c>
#include <windows.h>
const FILETIME FILETIME_none={0,0};
// The filesize and filemodified routines have been replaced by using WIN32_FIND_DATA's fields (fast!)
#include <tcconio.h>

LSet conf,badexts,badsubs,badfols;

int pathok(const char *path)
{
	for (int n=badfols.m-1;n>=0;n--)
		if (stristr(path,((char **)badfols.a)[n])) return 0;
	return 1;
}

int filemaxsize=0;

int fileok(const char *file,const double fsz)
{ // fsz=filesize(file)
	int n; char *s=strrchr(file,'.'),*b;
	if (s) for (n=badexts.m-1;n>=0;n--)
	{
		b=((char **)badexts.a)[n];
		if (stristr(b," in "))
		{
			char **e=explode(" in ",b),*d,x;
			streqi(&d,e[1]); strconcat(&d,"\\");
			x=(stristr(file,d) && !strcmpi(s+1,e[0]));
			free(d); explodefree(e);
			if (x) return 0;
		}
		else if (!strcmpi(s+1,b)) return 0;
	}
	for (n=badsubs.m-1;n>=0;n--)
		if (stristr(file,((char **)badsubs.a)[n])) return 0;
	if (filemaxsize>0 && fsz>filemaxsize) return 0;
	return 1;
}

int dirok(const char *dir)
{
	if (stristr(dir,"\\.") || stristr(dir,"\\..") || stristr(dir,"\\RECYCLER")) return 0;
	return 1;
}

void strnorm(char *s)
{
	while (*s)
	{
		if (*s==' ') *s='_';
		//else *s=lc(*s); // Uncomment to convert all to lowercase
		s++;
	}
}

int strcmpnorm(char *a,char *b)
{
	char c,d;
	do
	{
		c=*a; d=*b;
		if (c==' ') c='_'; else c=lc(c);
		if (d==' ') d='_'; else d=lc(d);
		if (c!=d) return c-d;
		a++; b++;
	}
	while (c && d);
	return 0;
}

int operator >(FILETIME a,FILETIME b)
{
	if (a.dwHighDateTime!=b.dwHighDateTime) return a.dwHighDateTime>b.dwHighDateTime;
	return a.dwLowDateTime>b.dwLowDateTime;
}
int operator ==(FILETIME a,FILETIME b)
{
	return a.dwHighDateTime==b.dwHighDateTime && a.dwLowDateTime==b.dwLowDateTime;
}
int operator !=(FILETIME a,FILETIME b)
{
	return a.dwHighDateTime!=b.dwHighDateTime || a.dwLowDateTime!=b.dwLowDateTime;
}
#include <math.h>
FILETIME operator +(const FILETIME a,const double s)
{ // Adds seconds onto FILETIME
	long double x=((a.dwHighDateTime*powl(2,32)+a.dwLowDateTime)*100e-9+s)/100e-9;
	FILETIME ret; ret.dwHighDateTime=floorl(x/powl(2,32)); ret.dwLowDateTime=fmodl(x,powl(2,32));
	return ret;
}

#include <rnd/createdirchain.c>

char *here,*there; const int stol=10; // Tolerance for different timestamps

void backup(const char *path)
{
	if (!pathok(path)) {printf("Skipping %s\n",path); return;}
    char sp[80]; memcpy(sp,path,min(69,strlen(path)+1)); sp[70]=0;
	textcolor(9); printf("%s",sp); clreol(); printf("\r"); textcolor(7);
	int n; char *hp,*hpx,*tp,*tpx;
	streqi(&hp,here); streqi(&tp,there);
	if (*path)
	{
		if (hp[strlen(hp)-1]!='\\') strconcat(&hp,"\\");
		if (tp[strlen(tp)-1]!='\\') strconcat(&tp,"\\");
	}
	strconcat(&hp,path); strconcat(&tp,path);
	typedef struct {char *f,h,t,d; double hsz,tsz; FILETIME hm,tm;} FileRec;
	LSet files=LSet(FileRec); FileRec *a,r; char ok;
	WIN32_FIND_DATA fd; streqi(&hpx,hp); strconcat(&hpx,"\\*.*");
	HANDLE h=FindFirstFile(hpx,&fd);
	while (h!=INVALID_HANDLE_VALUE) // Search loop (files here)
	{
		if (files.m>0 && files.m%100==0) {textcolor(9); printf("%s",sp); textcolor(3); printf(" %d",files.m); clreol(); printf("\r"); textcolor(7);}
		streq(&hpx,hp); strconcat(strconcat(&hpx,"\\"),fd.cFileName);
		r.d=!!(fd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY);
		r.hsz=((double)fd.nFileSizeHigh*MAXDWORD)+fd.nFileSizeLow; r.tsz=-1;
		r.hm=fd.ftLastWriteTime; r.tm=FILETIME_none;
		if (r.d) ok=dirok(hpx); else ok=fileok(hpx,r.hsz);
		if (ok)
		{
			streqi(&r.f,fd.cFileName); r.h=1; r.t=0;
			LSet_add(&files,&r);
		}
		if (FindNextFile(h,&fd)==0) {FindClose(h); h=INVALID_HANDLE_VALUE;}
	}
	streqi(&tpx,tp); strconcat(&tpx,"\\*.*");
	h=FindFirstFile(tpx,&fd);
	for (int cn=0;h!=INVALID_HANDLE_VALUE;cn++) // Search loop (files there)
	{
		if (cn>0 && cn%100==0) {textcolor(9); printf("%s",sp); textcolor(4); printf(" %d",cn); clreol(); printf("\r"); textcolor(7);}
		a=(FileRec *)files.a;
		for (n=files.m-1;n>=0;n--) if (!strcmpnorm(a[n].f,fd.cFileName))
		{
			a[n].t=1;
			a[n].tsz=((double)fd.nFileSizeHigh*MAXDWORD)+fd.nFileSizeLow;
			a[n].tm=fd.ftLastWriteTime;
			n=-10;
		}
		if (n>-10)
		{
			streq(&tpx,tp); strconcat(strconcat(&tpx,"\\"),fd.cFileName);
			r.d=!!(fd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY);
			if (r.d) ok=dirok(tpx); else ok=1;
			if (ok)
			{
				streqi(&r.f,fd.cFileName); r.h=0; r.t=1; r.hsz=-1; r.hm=FILETIME_none;
				r.tsz=((double)fd.nFileSizeHigh*MAXDWORD)+fd.nFileSizeLow;
				r.tm=fd.ftLastWriteTime;
				LSet_add(&files,&r);
			}
		}
		if (FindNextFile(h,&fd)==0) {FindClose(h); h=INVALID_HANDLE_VALUE;}
	}
	a=(FileRec *)files.a;
	for (n=files.m-1;n>=0;n--)
	{
		if ((1+n)%100==0) {textcolor(9); printf("%s",sp); textcolor(2); printf(" %d",1+n); clreol(); printf("\r"); textcolor(7);}
		streq(&hpx,hp); streq(&tpx,tp);
		strconcat(strconcat(&hpx,"\\"),a[n].f);
		if (a[n].h) // Add/merge
		{
			//strnorm(a[n].f); // Don't know why I had this here, switched off 2007-May-18 because it cocked up backing up
			strconcat(strconcat(&tpx,"\\"),a[n].f);
			if (a[n].d)
			{
				if (!a[n].t) {printf("Making dir %s%s%s\n",path,(*path?"\\":""),a[n].f); CreateDirectory(tpx,NULL);}
				streq(&hpx,path);
				if (*hpx) strconcat(&hpx,"\\"); strconcat(&hpx,a[n].f);
				backup(hpx);
			}
			else
			{
				if (a[n].tm!=FILETIME_none)
				{
					if ((a[n].hm>a[n].tm+stol) || (a[n].tm>a[n].hm+stol)) // Don't copy near-identically-timestamped files
					{
						if (a[n].hm>a[n].tm+stol) printf("Updating %s%s%s\n",path,(*path?"\\":""),a[n].f);
						else if (a[n].tm>a[n].hm+stol)
						{
							printf("Backing up %s%s%s\n",path,(*path?"\\":""),a[n].f);
							char *s,*bu; for (s=tpx+strlen(tpx)-1;s>tpx && *s!='\\';s--);
							streqi(&bu,"newer"); if (*s!='\\') strconcat(&bu,"\\"); strconcat(&bu,s); createdirchain(bu,0);
							CopyFile(tpx,bu,0); SetFileAttributes(tpx,FILE_ATTRIBUTE_NORMAL);
							free(bu);
							printf("Replacing %s%s%s\n",path,(*path?"\\":""),a[n].f);
						}
						CopyFile(hpx,tpx,0); SetFileAttributes(tpx,FILE_ATTRIBUTE_NORMAL);
					}
				}
				else
				{
					printf("Copying %s%s%s\n",path,(*path?"\\":""),a[n].f);
					CopyFile(hpx,tpx,0); SetFileAttributes(tpx,FILE_ATTRIBUTE_NORMAL);
				}
			}
		}
		else // Remove
		{
			strconcat(strconcat(&tpx,"\\"),a[n].f);
			if (a[n].d)
			{
				streq(&hpx,path);
				if (*hpx) strconcat(&hpx,"\\"); strconcat(&hpx,a[n].f);
				backup(hpx);
				printf("Removing dir %s%s%s\n",path,(*path?"\\":""),a[n].f); RemoveDirectory(tpx);
			}
			else {printf("Deleting %s%s%s\n",path,(*path?"\\":""),a[n].f); DeleteFile(tpx);} // Note this will delete "too large" files from the remote server too
		}
	}
	for (n=files.m-1;n>=0;n--) free(a[n].f); LSet_free(files);
	free(hp); free(hpx); free(tp); free(tpx);
}

#include <rnd/setcwdtohomedir.c>
#include <rnd/explodelset.c>

void main(int argc,char *argv[])
{
	setcwdtohomedir(argv[0]);
	conf=readconfig("config.txt");
	badexts=explodelset(",",configget(conf,"Exclude extensions"));
	badsubs=explodelset(",",configget(conf,"Exclude substrings"));
	badfols=explodelset(",",configget(conf,"Exclude folders"));
	if (argc==1)
	{
		for (int n=1;;n++)
		{
			here=configgetnth(conf,"Local address",n);
			there=configgetnth(conf,"Destination",n);
			if (!here || !there) break;
			filemaxsize=atoi(configgetnth(conf,"max size",n));
			printf("Backing up %s to %s",here,there);
			if (filemaxsize) printf(" (files under %d bytes)",filemaxsize);
			printf("\n");
			createdirchain(there,1);
			backup("");
		}
	}
	else if (argc==3)
	{
		here=argv[1];
		there=argv[2];
		backup("");
	}
	else {printf("Wrong number of arguments\n"); return;}
}
